[retour au README.md](../../../README.md)  
[Retour aux Documents](../../README_DOCUMENTS.md)  
[Retour au diagramme de classes](../README_DIAGRAMMES.md)  

## Diagramme de classe
```plantuml
@startuml
class Athlete {
    + getAthlete(): Athlete
    + getStatistic(): ?array
    + getUsersList(): array
    + getUserList(user: User): User
    + CheckAdd(user: User): bool
    + addUser(user: User): bool
    + removeUser(user: User): bool
}

abstract class Coach {
    + abstract getUsersList(): ?array
    + abstract getUserList(user: User): User
}

class CoachAthlete {
    + getUsersList(): ?array
    + getUserList(user: User): User
}

abstract class Role {
    - int id
    - array usersList
    - TrainingRepository trainingRepository
    + abstract __construct(trainingRepository: ?TrainingRepository)
    + abstract getUsersList(): ?array
    + abstract getUserList(user: User): User
    + abstract getTraining(): ?TrainingRepository
    + abstract getTrainingsList(): ?array
    + abstract getTrainingList(training: Training): ?Training
    + abstract CheckAdd(user: User): bool
    + abstract CheckAddTraining(training: Training): bool
    + abstract addUser(user: User): bool
    + abstract removeUser(user: User): bool
    + abstract addTraining(training: Training): bool
    + abstract removeTraining(training: Training): bool
}

class User {
    - int id
    - String username
    - string nom
    - string prenom
    - string email
    - string motDePasse
    - string sexe
    - float taille
    - float poids
    - DateTime dateNaissance
    + __construct(id: int, username: String, nom: string, prenom: string, email: string, motDePasse: string, sexe: string, taille: float, poids: float, dateNaissance: DateTime, role: Role)
    + getId(): int
    + setId(id: int): void
    + getUsername(): String
    + setUsername(username: int): void
    + getNom(): string
    + setNom(nom: string): void
    + getPrenom(): string
    + setPrenom(prenom: string): void
    + getEmail(): string
    + setEmail(email: string): void
    + getMotDePasse(): string
    + setMotDePasse(motDePasse: string): void
    + getSexe(): string
    + setSexe(sexe: string): void
    + getTaille(): float
    + setTaille(taille: float): void
    + getPoids(): float
    + setPoids(poids: float): void
    + getDateNaissance(): DateTime
    + setDateNaissance(dateNaissance: DateTime): void
    + getRole(): Role
    + setRole(role: Role): void
    + isValidPassword(password: string): bool
    + __toString(): String
}

class Statistique {
    - idStat: int
    - distanceTotale: float
    - poids: float
    - tempsTotal: time
    - FCmoyenne: int
    - FCmin: int
    - FCmax: int
    - cloriesBrulees: int
    + getIdStat(): int
    + getDistanceTotale(): float
    + getPoids(): float
    + getTempsTotal(): time
    + getFCmoyenne(): int
    + getFCmin(): int
    + getFCmax(): int
    + getCloriesBrulees(): int
    + __toString(): String
}

CoachAthlete --|> Coach
Coach --|> Role
Athlete --|> Role
User -> Role : role
Role -> User : usersList
Athlete -> Statistique : statsList
@enduml
````
